unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Algemeen;

type
  TForm1 = class(TForm)
    Image1: TImage;
    procedure starten(Sender: TObject);
    procedure gedrukt(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  N : integer = 500;
  d : integer = 10;
var
  Wijd,Hoog : integer;
  x : array of double;
  max : double;

function Gauss(sigma,t,x : double) : double;
begin
  Gauss := exp(-sqr(x/sigma)/2)/(t*sigma*sqrt(2*Pi))
end;

procedure initieel;
{
  Initialize
}
var
  k,t : integer;
  p,q : double;
begin
  Wijd := Form1.Image1.Width;
  Hoog := Form1.Image1.Height;

  Setlength(x,N);
  t := 0;
  Form1.Image1.Canvas.Pen.Color := clGreen;
  for k := 0 to N-1 do
  begin
    p := Random;
    q := Random;
    if q > sqr(sin(2*Pi*p)) then Continue;
    x[t] := p;
    t := t + 1;
  end;
{ for k := 0 to N-1 do
    x[k] := 0.5*Random;
  t := N; }
  SetLength(x,t);
end;

procedure tekenen;
{
  Draw Density
}
var
  W,H,k,i,j,t : integer;
  y : double;
begin
  ClearDevice(Form1.Image1);
  W := Wijd-1;
  H := Hoog-1;
  t := Length(x);
  for k := 0 to t-1 do
  begin
    i := Round(x[k]*W);
    with Form1.Image1.Canvas do
    begin
      MoveTo(i,H) ; LineTo(i,H-d);
    end;
  end;

  Form1.Image1.Canvas.Pen.Color := clBlack;
  for i := 0 to W do
  begin
    y := 0;
    for k := 0 to t-1 do
      y := y + 0.5*Gauss(max,t,i/W-x[k]);
    j := Round(H*(1-y));
    with Form1.Image1.Canvas do
      if i > 0 then LineTo(i,j)
               else MoveTo(i,j);
  end;
end;

function maximum : double;
var
  i,t : integer;
  dx,max : double;
begin
  max := 0;
  t := Length(x);
  for i := 1 to t-1 do
  begin
    dx := x[i]-x[i-1];
    if dx > max then max := dx;
  end;
  Writeln('Spread = ',max);
  maximum := max;
end;

procedure TForm1.starten(Sender: TObject);
{
  On Create
}
begin
  Initieel;
  Sorteer(x);
  max := maximum;
  Tekenen;
end;

procedure berekenen;
{
  Calculation
}
var
  k,t : integer;
begin
  t := length(x);
  for k := 0 to t-1 do
  begin
    x[k] := Algemeen.volgende(x[k]);
    if x[k] > 1 then x[k] := x[k] - 1;
  end;
  Sorteer(x);
  Tekenen;
end;

procedure TForm1.gedrukt(Sender: TObject; var Key: Char);
{
  On KeyPress
}
begin
  berekenen;
end;

end.
