Unit Algemeen;

INTERFACE

Uses ExtCtrls, Graphics, Types, SysUtils;

function volgende(x : double) : double;
procedure ClearDevice(scherm : TImage);
procedure Sorteer(var rij : array of double);

IMPLEMENTATION

function Masker : integer;
{
  Bit Mask
}
var
  k,M : integer;
begin
  M := 0;
  for k := 0 to 30 do
    M := (M shl 1) or 1;
  Masker := M;
end;

function volgende(x : double) : double;
{
  Next 0 < integer < 1
  in Bernoulli mapping
}
var
  L : integer;
  i,b : integer;
begin
  for i := 0 to 15 do
    x := x * 2;
  L := (Trunc(x) shl 1) and Masker;
  if Random > 0.5 then b := 1 else b := 0;
  x := L or b;
  for i := 0 to 15 do
    x := x / 2;
  if x > 1 then x := x - 1;
  volgende := x;
end;

procedure ClearDevice(scherm : TImage);
{
  Clear Screen
}
var
  rechthoek : TRect;
  W,H : integer;
begin
  W := scherm.Width;
  H := scherm.Height;
  rechthoek := Rect(0,0,W,H);
  with scherm.Canvas do
  begin
    Brush.Color := clWhite;
    FillRect(rechthoek);
  end;
end;

procedure Sorteer(var rij : array of double);
{
  Straight insertion sort.
  Algorithm S on page 81 of "The Art of Computer Programming"
  volume 3 / "Sorting and Searching" by Donald E. Knuth
}
var
  LIM,m,k,L : integer;
  g : double;
begin
  L := 0;
  LIM := Length(rij)-1;
  for m := 2 to LIM do
  begin
    g := rij[m];
    if g >= rij[m-1] then Continue;
    for k := 1 to (m-1) do
    begin
      if g < rij[m-k] then
        rij[m-k+1] := rij[m-k]
      else Break;
      L := k;
    end;
    rij[m-L+1] := rij[m-L];
    rij[m-L] := g;
  end;
end;

END.
